SG2 = LibStub("AceAddon-3.0"):NewAddon("SG2", "AceHook-3.0", "AceTimer-3.0")

-- Touch of the Occult in BfA

local SG2AlreadyCalled = false
local EquippedGlovesID = 1
local SG2Disabled = true
local SG2Mining = false
local SG2Skinning = false
local SG2Herbalism = false
local SG2HasGloves = false
local SG2Archaelogy = false
local SG2ArchaelogySurveyString = ""
local DebugSkinningCombatTimer2Set = false

SG2DebugString = "Empty"

-- ~ Initial Release
local SG2frame = CreateFrame("FRAME");
SG2frame:RegisterEvent("PLAYER_LOGOUT");
SG2frame:RegisterEvent("ADDON_LOADED");

function SG2frame:OnEvent(event, arg)
  if event == "ADDON_LOADED" and arg == "StickyGloves" then
    print("StickyGloves loaded: BfA")
    if SG2FirstRun == nil then
      SG2FirstRun = true;
    end
  elseif event == "PLAYER_LOGOUT" then
    SG2FirstRun = false;
  end
end

SG2frame:SetScript("OnEvent", SG2frame.OnEvent);

function SG2:OnEnable()
  self:ScheduleTimer("WelcomeTimer", 3)
end

-- Local Translations for Objects not available through internal lookups

-- BfA Herbs
function SG2:GetZinanthidHerbString()
  if (GetLocale() == "enUS") then
    return("Zin'anthid")
  else
    return("Zin'anthid")
  end
end
function SG2:GetRiverbudHerbString()
  if (GetLocale() == "enUS") then
    return("Riverbud")
  else
    return("Riverbud")
  end
end
function SG2:GetSeaStalkHerbString()
  if (GetLocale() == "enUS") then
    return("Sea Stalk")
  else
    return("Sea Stalk")
  end
end
function SG2:GetStarMossHerbString()
  if (GetLocale() == "enUS") then
    return("Star Moss")
  else
    return("Star Moss")
  end
end
function SG2:GetAkundasBiteHerbString()
  if (GetLocale() == "enUS") then
    return("Akunda's Bite")
  else
    return("Akunda's Bite")
  end
end
function SG2:GetWintersKissHerbString()
  if (GetLocale() == "enUS") then
    return("Winter's Kiss")
  else
    return("Winter's Kiss")
  end
end
function SG2:GetSirensStingHerbString()
  if (GetLocale() == "enUS") then
    return("Siren's Sting")
  else
    return("Siren's Sting")
  end
end
function SG2:GetAnchorWeedHerbString()
  if (GetLocale() == "enUS") then
    return("Anchor Weed")
  else
    return("Anchor Weed")
  end
end

-- BfA mining nodes
function SG2:GetOsmeniteDepositString()
  if (GetLocale() == "enUS") then
    return("Osmenite Deposit")
  else
    return("Osmenite Deposit")
  end
end
function SG2:GetRichOsmeniteDepositString()
  if (GetLocale() == "enUS") then
    return("Rich Osmenite Deposit")
  else
    return("Rich Osmenite Deposit")
  end
end
function SG2:GetOsmeniteSeamString()
  if (GetLocale() == "enUS") then
    return("Osmenite Seam")
  else
    return("Osmenite Seam")
  end
end
function SG2:GetMoneliteDepositString()
  if (GetLocale() == "enUS") then
    return("Monelite Deposit")
  else
    return("Monelite Deposit")
  end
end
function SG2:GetMoneliteSeamString()
  if (GetLocale() == "enUS") then
    return("Monelite Seam")
  else
    return("Monelite Seam")
  end
end
function SG2:GetStormSilverDepositString()
  if (GetLocale() == "enUS") then
    return("Storm Silver Deposit")
  else
    return("Storm Silver Deposit")
  end
end
function SG2:GetStormSilverSeamString()
  if (GetLocale() == "enUS") then
    return("Storm Silver Seam")
  else
    return("Storm Silver Seam")
  end
end
function SG2:GetPlatinumDepositString()
  if (GetLocale() == "enUS") then
    return("Platinum Deposit")
  else
    return("Platinum Deposit")
  end
end

function SG2:SG2OnUpdate(frame)
  --While in BfA zones

  local map = C_Map.GetMapInfo(C_Map.GetBestMapForUnit("player"))
  local parent = C_Map.GetMapInfo(map.parentMapID)
  if parent.name == "Kul Tiras" or parent.name == "Zandalar" or parent.name == "Azeroth" then

    if GameTooltip:GetOwner() ~= Minimap then
      local ArchyMatch = false
      local SkinningMatch = false
      local Typetext = GameTooltipTextLeft2:GetText()
      if Typetext == nil then
        Typetext = ""
      end
      local text = GameTooltipTextLeft1:GetText()
      local PositiveToolTipMatch = false
      -- Warn about being unable to equip due to combat
      if InCombatLockdown() == true then
        if SG2Skinning == true then
          local Skinningtext = GameTooltipTextLeft3:GetText()
          if Skinningtext == nil then
            Skinningtext = ""
          end
          if string.match(Skinningtext, getglobal("UNIT_SKINNABLE_LEATHER")) then
            if DebugSkinningCombatTimer2Set == false then
              DebugSkinningCombatTimer2Set = true
              self:ScheduleTimer("SkinningWarningTimer", 1)
            end
          end
        end
      end
      if InCombatLockdown() == false then
        if SG2AlreadyCalled == false then
          -- Check for Archaeology
          if SG2Archaelogy == true then
            if text == nil then
              -- Do nothing
            else
              if string.match(text, SG2ArchaelogySurveyString) then
                ArchyMatch = true
                PositiveToolTipMatch = true
              end
            end
          end
          -- Run Through Mining Possible Matches
          if SG2Mining == true then
            if (GetLocale() == "esES") then
              SkinnableRock = "Minería"
            elseif (GetLocale() == "frFR") then
              SkinnableRock = "Minage"
            elseif (GetLocale() == "deDE") then
              SkinnableRock = "Bergbau"
            elseif (GetLocale() == "esMX") then
              SkinnableRock = "Minería"
            elseif (GetLocale() == "ptBR") then
              SkinnableRock = "Mineração"
            elseif (GetLocale() == "ruRU") then
              SkinnableRock = "горного дела"
            else
              SkinnableRock = "Mining"
            end
            if string.match(Typetext, SkinnableRock) then

              -- BfA mining nodes
              if string.match(text, SG2:GetOsmeniteDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetOsmeniteSeamString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetMoneliteDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetMoneliteSeamString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetStormSilverDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetStormSilverSeamString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetPlatinumDepositString()) then
                PositiveToolTipMatch = true
              end

            end
          end
          -- Run Through Herbalism Possible Matches
          if SG2Herbalism == true then
            if (GetLocale() == "esES") then
              -- Fix for Blizzard's Typo on GetGlobal
              SkinnableHerb = "Herboristería"
            elseif (GetLocale() == "frFR") then
              SkinnableHerb = "Herboristerie"
            elseif (GetLocale() == "deDE") then
              SkinnableHerb = "Kräuterkunde"
            elseif (GetLocale() == "esMX") then
              SkinnableHerb = "Herboristería"
            elseif (GetLocale() == "ptBR") then
              SkinnableHerb = "Herborismo"
            elseif (GetLocale() == "ruRU") then
              SkinnableHerb = "Травничество"
            else
              SkinnableHerb = "Herbalism"
            end
            if string.match(Typetext, SkinnableHerb) or string.match(Typetext, "Requires Herbalism") then

              -- BfA herbs
              if string.match(text, SG2:GetZinanthidHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetRiverbudHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetSeaStalkHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetStarMossHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetAkundasBiteHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetWintersKissHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetSirensStingHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetAnchorWeedHerbString()) then
                PositiveToolTipMatch = true
              end

            end
          end
          -- Run through Skinning Possible Matches
          if SG2Skinning == true then
            local Skinningtext = GameTooltipTextLeft3:GetText()
            if Skinningtext == nil then
              Skinningtext = ""
            end
            if string.match(Skinningtext, getglobal("UNIT_SKINNABLE_LEATHER")) then
              PositiveToolTipMatch = true
              SkinningMatch = true
            end
          end

          if PositiveToolTipMatch == true then
            SG2AlreadyCalled = true
            if GetInventoryItemID("player", 10) == 45840 then
              -- Null
            else
              EquippedGlovesID = GetInventoryItemID("player", 10)
              if GetCVar("Sound_EnableSFX") == "1" then
                ReenableSound = true
                SetCVar("Sound_EnableSFX", 0)
              end
              EquipItemByName(45840)
              if ReenableSound == true then
                SetCVar("Sound_EnableSFX", 1)
                ReenableSound = false
              end
            end
            if ArchyMatch == true then
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 9)
            else
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 5)
            end
          end
        else
          if SG2Archaelogy == true then
            if text == nil then
              -- Do nothing
            else
              if string.match(text, SG2ArchaelogySurveyString) then
                ArchyMatch = true
                PositiveToolTipMatch = true
              end
            end
          end

          -- Run Through Mining Possible Matches
          if SG2Mining == true then
            if (GetLocale() == "esES") then
              SkinnableRock = "Minería"
            elseif (GetLocale() == "frFR") then
              SkinnableRock = "Minage"
            elseif (GetLocale() == "deDE") then
              SkinnableRock = "Bergbau"
            elseif (GetLocale() == "esMX") then
              SkinnableRock = "Minería"
            elseif (GetLocale() == "ptBR") then
              SkinnableRock = "Mineração"
            elseif (GetLocale() == "ruRU") then
              SkinnableRock = "горного дела"
            else
              SkinnableRock = "Mining"
            end
            if string.match(Typetext, SkinnableRock) then

              -- BfA Mining
              if string.match(text, SG2:GetOsmeniteDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetOsmeniteSeamString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetMoneliteDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetMoneliteSeamString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetStormSilverDepositString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetStormSilverSeamString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetPlatinumDepositString()) then
                PositiveToolTipMatch = true
              end

            end
          end
          -- Run Through Herbalism Possible Matches
          if SG2Herbalism == true then
            if (GetLocale() == "esES") then
              -- Fix for Blizzard's Typo on GetGlobal
              SkinnableHerb = "Herboristería"
            elseif (GetLocale() == "frFR") then
              SkinnableHerb = "Herboristerie"
            elseif (GetLocale() == "deDE") then
              SkinnableHerb = "Kräuterkunde"
            elseif (GetLocale() == "esMX") then
              SkinnableHerb = "Herboristería"
            elseif (GetLocale() == "ptBR") then
              SkinnableHerb = "Herborismo"
            elseif (GetLocale() == "ruRU") then
              SkinnableHerb = "Травничество"
            else
              SkinnableHerb = "Herbalism"
            end
            if string.match(Typetext, SkinnableHerb) or string.match(Typetext, "Requires Herbalism") then

              -- BfA herbs
              if string.match(text, SG2:GetZinanthidHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetRiverbudHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetSeaStalkHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetStarMossHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetAkundasBiteHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetWintersKissHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetSirensStingHerbString()) then
                PositiveToolTipMatch = true
              end
              if string.match(text, SG2:GetAnchorWeedHerbString()) then
                PositiveToolTipMatch = true
              end

            end
          end
          -- Run through Skinning Possible Matches
          if SG2Skinning == true then
            local Skinningtext = GameTooltipTextLeft3:GetText()
            if Skinningtext == nil then
              Skinningtext = ""
            end
            if string.match(Skinningtext, getglobal("UNIT_SKINNABLE_LEATHER")) then
              PositiveToolTipMatch = true
              SkinningMatch = true
            end
          end

          if PositiveToolTipMatch == true then
            if ArchyMatch == true then
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 9)
            elseif SkinningMatch == true then
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 3)
            else
              self:CancelAllTimers()
              self:ScheduleTimer("ResetTimer", 5)
            end
          end
        end
      end
    end
  end
end

function SG2:ResetTimer()
  if InCombatLockdown() == false then
    SG2AlreadyCalled = false
    if GetCVar("Sound_EnableSFX") == "1" then
      ReenableSound = true
      SetCVar("Sound_EnableSFX", 0)
    end
    EquipItemByName(EquippedGlovesID)
    if ReenableSound == true then
      SetCVar("Sound_EnableSFX", 1)
      ReenableSound = false
    end
  else
    self:ScheduleTimer("ResetTimer", 1)
  end
end

function SG2:SkinningWarningTimer()
  DebugSkinningCombatTimer2Set = false
  print("StickyGloves: Debug Warning, Can Not Equip while In Combat")
end

function SG2:DebugAdd(StringToAdd)
  if SG2DebugString == "Empty" then
    SG2DebugString = "" .. StringToAdd
  else
    SG2DebugString = SG2DebugString .. StringToAdd
  end
  return
end

function SG2:WelcomeTimer()
  -- Main Initialization
  SG2:DebugAdd(GetLocale())

  local RerunTimer = false
  local FirstProfession, SecondProfession, Archy, Fishing, Cooking, FirstAid = GetProfessions("player")

  -- Grab Data for Touch of the Occult
  BfAGlovesName, BfAGlovesItemLink, BfAGlovesRarity, BfAGlovesiLvl, BfAGlovesRequiredLevel, BfAGlovesType, BfAGlovesSubType, BfAGlovesMaxStack, BfAGlovesEquipLocation, BfAGlovesIcon, BfAGlovesVendorSellPrice = GetItemInfo(45840)

  -- BfAGlovesItemLink = "\124cff0070dd\124Hitem:45840:0:0:0:0:0:0:0:0:0:0\124h[Touch of the Occult]\124h\124r"

  if BfAGlovesName == nil then
    self:ScheduleTimer("WelcomeTimer", 3)
    SG2:DebugAdd("Delay on requesting gloves info, Rescheduled Event")
    print("StickyGloves: Can't find " .. BfAGlovesItemLink.. ". Trying again in 3 seconds.")
    RerunTimer = true
    return
  end

  if FirstProfession ~= nil then
    if GetProfessionInfo(FirstProfession) == nil then
      self:ScheduleTimer("WelcomeTimer", 3)
      SG2:DebugAdd("Delay on requesting Profession Details, Rescheduled Event")
      print("StickyGloves: Can't find profession details. Trying again in 3 seconds.")
      RerunTimer = true
    else
      if FirstProfession == nil then
        SG2:DebugAdd("Nill")
      else
        local FirstProfessionName, FirstProfessionIcon, FirstProfessionSkillLevel, FirstProfessionMaxSkill, FirstProfessionAbilities, FirstProfessionOffset, FirstProfessionSkillLine, FirstProfessionSkillModifier = GetProfessionInfo(FirstProfession)
        SG2:DebugAdd(FirstProfessionName)
        SG2:DebugAdd(FirstProfessionSkillLine)
        if FirstProfessionSkillLine == 186 then
          SG2Mining = true
          SG2Disabled = false
        elseif FirstProfessionSkillLine == 182 then
          SG2Herbalism = true
          SG2Disabled = false
        elseif FirstProfessionSkillLine == 393 then
          SG2Skinning = true
          SG2Disabled = false
        end
      end
    end

    if SecondProfession == nil then
      SG2:DebugAdd("Nill")
    else
      local SecondProfessionName, SecondProfessionIcon, SecondProfessionSkillLevel, SecondProfessionMaxSkill, SecondProfessionAbilities, SecondProfessionOffset, SecondProfessionSkillLine, SecondProfessionSkillModifier = GetProfessionInfo(SecondProfession)
      SG2:DebugAdd(SecondProfessionName)
      SG2:DebugAdd(SecondProfessionSkillLine)
      if SecondProfessionSkillLine == 186 then
        SG2Mining = true
        SG2Disabled = false
      elseif SecondProfessionSkillLine == 182 then
        SG2Herbalism = true
        SG2Disabled = false
      elseif SecondProfessionSkillLine == 393 then
        SG2Skinning = true
        SG2Disabled = false
      end
    end

    if Archy == nil then
      SG2Archaelogy = false
    else
      local ArchyName, ArchyRank, ArchyIcon, ArchyCost, ArchyMinRange, ArchyMaxRange = GetSpellInfo(80451)
      SG2ArchaelogySurveyString = ArchyName
      SG2Archaelogy = true
      SG2Disabled = false
    end
  else
    print("StickyGloves: Disabled due to No Professions on Character.")
    SG2Disabled = true
    SG2:DebugAdd("Disabled due to 0 Professions")
  end

  if RerunTimer == false then
    if UnitLevel("player") < 10 then
      SG2Disabled = true
      SG2:DebugAdd("Disabled due to current character being under Level 10.")
    end
    SG2:DebugAdd(UnitName("player"))

    -- Check Bags for Gloves
    for bag = 0, 4 do
      for slot = 1, GetContainerNumSlots(bag) do
        local item = GetContainerItemLink(bag, slot)
        if item and item:find(BfAGlovesName) then
          SG2HasGloves = true
        end
      end
    end

    if SG2HasGloves == false then
      SG2:DebugAdd("No Gloves")
      SG2Disabled = true
      if SG2FirstRun == true then
        print("SG: " .. BfAGlovesItemLink.. " could not be found in your bags.")
      end
    end

    if SG2Disabled == false then
      SG2:DebugAdd("All Good")
      self:HookScript(GameTooltip, "OnUpdate", "SG2OnUpdate")
      print("SG: Swapping " .. BfAGlovesItemLink .. " in BfA zones.")
    end
  end
end
